﻿using Infragistics.Controls.Charts;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = ChartData.GenerateData(10);
        }

        int columnIndex = 0;

        private void ColumnSeries_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (columnIndex == (this.DataContext as IEnumerable<object>).Count()-1)
            {
                Path p1 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex ] as Marker), typeof(Path), true) as Path;
                Path p2 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex - 1] as Marker), typeof(Path), true) as Path;
                p1.Fill = p2.Fill;
            }
            else
            {
                Path p1 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex ] as Marker), typeof(Path), true) as Path;
                Path p2 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex + 1] as Marker), typeof(Path), true) as Path;
                p1.Fill = p2.Fill;
            }

            (e.OriginalSource as Path).Fill = Brushes.PeachPuff;
            Point clikedColumn = (e.OriginalSource as Path).TranslatePoint(new Point(0, 0), (e.OriginalSource as Path).Parent as UIElement);

            ScalerParams sp = new ScalerParams((sender as LineSeries).SeriesViewer.WindowRect,
                                                (sender as LineSeries).SeriesViewer.ViewportRect,
                                                false);
            columnIndex = (int)(sender as LineSeries).XAxis.GetUnscaledValue(clikedColumn.X, sp);
        }

        private void Window_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Left && columnIndex > 0)
            {
                Path p1 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex] as Marker), typeof(Path), true) as Path;
                Path p2 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex - 1] as Marker), typeof(Path), true) as Path;

                p1.Fill = p2.Fill;
                p2.Fill = Brushes.PeachPuff;

                columnIndex--;
            }
            if (e.Key == Key.Right && columnIndex >= 0 && columnIndex < (this.DataContext as IEnumerable<object>).Count() - 1)
            {
                Path p1 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex] as Marker), typeof(Path), true) as Path;
                Path p2 = Utilities.GetDescendantFromType((((xamDataChart1.Series[0] as LineSeries).RootCanvas.Children[0] as Canvas).Children[columnIndex + 1] as Marker), typeof(Path), true) as Path;

                p1.Fill = p2.Fill;
                p2.Fill = Brushes.PeachPuff;

                columnIndex++;
            }
        }
    }

    public class ChartData
    {
        public DateTime Date { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }

        public static ObservableCollection<ChartData> GenerateData(int count)
        {
            ObservableCollection<ChartData> data = new ObservableCollection<ChartData>();

            Random r = new Random();

            ChartData data0 = new ChartData
            {
                Date = DateTime.Now,
                Value1 = r.Next(20, 40),
                Value2 = r.Next(20, 40),
                Value3 = r.Next(20, 40),
            };

            data.Add(data0);

            for (int i = 1; i < count; i++)
            {
                ChartData dat = new ChartData
                {
                    Date = DateTime.Now.AddDays(i),
                };

                if (r.NextDouble() > .5)
                {
                    dat.Value1 = data[i - 1].Value1 + r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 + r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 + r.NextDouble();
                }
                else
                {
                    dat.Value1 = data[i - 1].Value1 - r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 - r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 - r.NextDouble();
                }

                data.Add(dat);
            }

            return data;
        }
    }
}
